#GNU public license
#This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 # 
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 # 
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the
 # Free Software Foundation, Inc.,
 # 51 Franklin Street, Fifth Floor,
 # Boston, MA  02110-1301, USA.

#Processing order(if files included in root folder)
#Export to ProRes4444 and/or ProRes proxy(MOV, mts etc, includes HDR mov) 
#Manually selected FLATFRAMES processing
#Fully automated flatframe processing
#Automated darkframe processing
#extra round to check if darkframe or flatframe still are present in root folder
#Create darkframe MLV files from storage folder
#Processing of MLV files
#cr2hdr processing(MLV files)
#Processing of RAW files
#cr2hdr processing(RAW files)
#Export to ProRes4444 and/or ProRes proxy
#run cr2hdr 4 processes in parallel(CR2,DNG,dng files)

workingDir=`dirname "$0"`
cd "${workingDir}"

mkdir -p A_ORIGINALS

export PATH="${workingDir}":$PATH

###############################################################
#Processing MLV files into folders with dng files
#Will take white space
    OLDIFS=$IFS
    IFS=$'\n'
#Processing MLV files into folders with dng files
#If prefixed with avg_ it will ignore it as a darkframe file
    for FILE in `ls -A1 *.MLV *.mlv | grep -v 'avg_\|ft_' 2>/dev/null`; do
    date=$(mlv_dump -m -v "$FILE" | grep 'Date' | head -1 | awk 'FNR == 1 {print $2}')
    date_01=$(echo "$date" | head -c2)
    date_02=$(echo "$date" | cut -c4-5)
    date_03=$(echo "$date" | cut -c7-10)
    date=$(echo "$date_03"-"$date_02"-"$date_01""_0001_C0000")

    BASE=`echo $FILE | cut -d "." -f1`;
    mkdir "$O""${BASE}"
    mv "$O""${BASE}" "$O""${BASE}_1_$date" 
    mv "$FILE" "${BASE}_1_$date"
    mv "$BASE".M* "${BASE}_1_$date"
    cd "${BASE}_1_$date"
#Hardcoded blackfix 
bl=$(printf "%s\n" --black-fix=1780)

#reset IFS
    IFS=$OLDIFS
#frame extraction in mlv_dump makes multihtreading possible. Thanks to so-rose for highlighting this possibility
    frct=$(mlv_dump -f 0-1 --dng $mlv $bl -o "$O2""${BASE}_1_$date"_ "$FILE" | awk '/Processed/ { print $2; }')
    mlv_dump -f 2-$(($frct/4)) --dng $mlv $bl -o "$O2""${BASE}_1_$date"_ "$FILE" &
    mlv_dump -f $(($frct/4+1))-$(($frct/4+1+$frct/4)) --dng $mlv $bl -o "$O2""${BASE}_1_$date"_ "$FILE" &
    mlv_dump -f $(($frct/4+1+$frct/4+1))-$(($frct/4+1+$frct/4+1+$frct/4)) --dng $mlv $bl -o "$O2""${BASE}_1_$date"_ "$FILE" &
    mlv_dump -f $(($frct/4+1+$frct/4+1+$frct/4+1))-$frct --dng $mlv $bl -o "$O2""${BASE}_1_$date"_ "$FILE"
#move mlv originals to folder 
    mv -i "${BASE}".MLV ../A_ORIGINALS ;
    mv -i "${BASE}".M* ../A_ORIGINALS ;
cd ..
done 
###############################################################

#Thanks to A1ex(cr2hdr, raw2dng, mlv_dump) g3gg0(mlv_dump) Dave Coffin(dcraw) Fabrice Bellard(FFmpeg) Phil Harvey(Exiftool) Andreas Huggel(exiv2) BWF MetaEdit(FADGI) dfort(Focus pixel script).
#Copyright Danne
